/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.BreastGYNMammoSNOMEDMap;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_BreastBiopsyTechniques;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_BreastBiopsyTechniques;


/**
 * This class represents BreastBiopsyTechniques - CID6060
 */
public class BreastBiopsyTechniques_CID6060 
{
	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Instantiates a new BreastBiopsyTechniques_CID6060 Template 
	 */
	public BreastBiopsyTechniques_CID6060()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}

	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumBreastBiopsyTechniques Object of EnumCM_BreastBiopsyTechniques represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_BreastBiopsyTechniques enumBreastBiopsyTechniques)
	{
		switch(enumBreastBiopsyTechniques)
		{
		case LUMPECTOMY: this.strCodeValue =EnumCV_BreastBiopsyTechniques.LUMPECTOMY_P1_03005.getValue(); break;
		case MASTECTOMY: this.strCodeValue =EnumCV_BreastBiopsyTechniques.MASTECTOMY_P1_43850.getValue(); break;
		case QUADRANTECTOMY_OF_BREAST: this.strCodeValue =EnumCV_BreastBiopsyTechniques.QUADRANTECTOMY_OF_BREAST_P1_4834A.getValue(); break;
		case DIAGNOSTIC_RADIOGRAPHY_STEREOTACTIC_LOCALIZATION: this.strCodeValue =EnumCV_BreastBiopsyTechniques.DIAGNOSTIC_RADIOGRAPHY_STEREOTACTIC_LOCALIZATION_P5_00032.getValue(); break;
		case ULTRASONIC_GUIDANCE_PROCEDURE: this.strCodeValue =EnumCV_BreastBiopsyTechniques.ULTRASONIC_GUIDANCE_PROCEDURE_P5_B0700.getValue(); break;
		case MAMMOGRAPHY: this.strCodeValue =EnumCV_BreastBiopsyTechniques.MAMMOGRAPHY_P5_40010.getValue(); break;
		case MAMMOGRAPHIC_CROSSHAIR: this.strCodeValue =EnumCV_BreastBiopsyTechniques.MAMMOGRAPHIC_CROSSHAIR_111487.getValue(); break;
		case MAMMOGRAPHIC_GRID: this.strCodeValue =EnumCV_BreastBiopsyTechniques.MAMMOGRAPHIC_GRID_111488.getValue(); break;
		case MAGNETIC_RESONANCE_IMAGING_GUIDED_BIOPSY: this.strCodeValue =EnumCV_BreastBiopsyTechniques.MAGNETIC_RESONANCE_IMAGING_GUIDED_BIOPSY_P1_03107.getValue(); break;
		case COMPUTED_TOMOGRAPHY_GUIDED_BIOPSY: this.strCodeValue =EnumCV_BreastBiopsyTechniques.COMPUTED_TOMOGRAPHY_GUIDED_BIOPSY_P1_03106.getValue(); break;
		case PALPATION_GUIDED: this.strCodeValue =EnumCV_BreastBiopsyTechniques.PALPATION_GUIDED_111489.getValue(); break;
		case VACUUM_ASSISTED: this.strCodeValue =EnumCV_BreastBiopsyTechniques.VACUUM_ASSISTED_111490.getValue(); break;}
	}
	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumBreastBiopsyTechniques Object of EnumCM_BreastBiopsyTechniques represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_BreastBiopsyTechniques enumBreastBiopsyTechniques)
	{
		switch(enumBreastBiopsyTechniques)
		{
		case LUMPECTOMY : this.strSNOMEDCTID =BreastGYNMammoSNOMEDMap.LUMPECTOMY.getSNOMEDCTID(); break;
		case QUADRANTECTOMY_OF_BREAST : this.strSNOMEDCTID =BreastGYNMammoSNOMEDMap.QUADRANTECTOMY_OF_BREAST.getSNOMEDCTID(); break;
		case DIAGNOSTIC_RADIOGRAPHY_STEREOTACTIC_LOCALIZATION : this.strSNOMEDCTID =BreastGYNMammoSNOMEDMap.DIAGNOSTIC_RADIOGRAPHY_STEREOTACTIC_LOCALIZATION.getSNOMEDCTID(); break;
		case ULTRASONIC_GUIDANCE_PROCEDURE : this.strSNOMEDCTID =BreastGYNMammoSNOMEDMap.ULTRASONIC_GUIDANCE_PROCEDURE.getSNOMEDCTID(); break;
		case MAMMOGRAPHY : this.strSNOMEDCTID =BreastGYNMammoSNOMEDMap.MAMMOGRAPHY.getSNOMEDCTID(); break;
		case MAGNETIC_RESONANCE_IMAGING_GUIDED_BIOPSY : this.strSNOMEDCTID =BreastGYNMammoSNOMEDMap.MAGNETIC_RESONANCE_IMAGING_GUIDED_BIOPSY.getSNOMEDCTID(); break;
		case COMPUTED_TOMOGRAPHY_GUIDED_BIOPSY : this.strSNOMEDCTID =BreastGYNMammoSNOMEDMap.COMPUTED_TOMOGRAPHY_GUIDED_BIOPSY.getSNOMEDCTID(); break;
		}
	}

	/**
	 * Sets the value for BreastBiopsyTechniques
	 * @param enumBreastBiopsyTechniques Object of EnumCM_BreastBiopsyTechniques.
	 */
	public void setBreastBiopsyTechniques(EnumCM_BreastBiopsyTechniques enumBreastBiopsyTechniques)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumBreastBiopsyTechniques.getValue();
		if(strCodeMeaning.equalsIgnoreCase(EnumCM_BreastBiopsyTechniques.MASTECTOMY.getValue())
				|| strCodeMeaning.equalsIgnoreCase(EnumCM_BreastBiopsyTechniques.MAMMOGRAPHIC_GRID.getValue())
				|| strCodeMeaning.equalsIgnoreCase(EnumCM_BreastBiopsyTechniques.MAMMOGRAPHIC_CROSSHAIR.getValue())
				|| strCodeMeaning.equalsIgnoreCase(EnumCM_BreastBiopsyTechniques.PALPATION_GUIDED.getValue())
				|| strCodeMeaning.equalsIgnoreCase(EnumCM_BreastBiopsyTechniques.VACUUM_ASSISTED.getValue()))
			this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.DCM.getValue();
		else
			this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumBreastBiopsyTechniques);
		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumBreastBiopsyTechniques);
	}
}
